import es
from cfglib import AddonCFG
from random import choice as rChoice
from gamethread import delayed

config = AddonCFG(es.getAddonPath('randweps') + '/randweps.cfg')

config.text('*******************************')
config.text('* RandWeps Configuration File *')
config.text('*******************************')
attacker_wep = config.cvar('randweps_attacker_weapon', 1, "0: Attacker (Killer) won't get new weapons, 1: Attacker will get all new only for headshots, 2: Attacker will get all new.")
god = config.cvar('randweps_god', 1, 'Attacker will be in God-mode for 1 second after the kill.')
objectives = config.cvar('randweps_objectives', 1, 'Enable/Disable map-objectives.')
buyzone = config.cvar('randweps_buyzone', 0, 'De-/Activate Buy-Zones.')
config.text('\n')
config.text('******************************')
config.text('* RandWeps Configuration End *')
config.text('******************************')

config.write()

player = {}
bomb = 0
sec = ['usp', 'glock', 'fiveseven', 'elite', 'p228', 'deagle']
prim = [
        'm3', 'xm1014', 
        'mac10', 'mp5navy', 'p90', 'tmp', 
        'galil', 'famas', 
        'm4a1', 'ak47', 'scout', 'awp',
        'sg552', 'aug'
        ]

names = {'usp':'USP', 'glock':'Glock 18C', 'fiveseven':'ES Five-Seven', 'elite':'.40 Dual Berettas', 'p228':'P228 Compact', 'deagle':'Deagle', 
         'm3':'M3 Pumpgun', 'xm1014':'XM-1014 Shotgun', 'mac10':'MAC-10', 'mp5navy':'MP5-Navy', 'p90':'P90', 'tmp':'TMP', 'galil':'Galil ARM',
         'famas':'Famas', 'm4a1':'Maverick M4A1 Carbine', 'ak47':'Automat Kalashnikov - 47', 'scout':'Steyr Scout', 'awp':'Artic Warefare Police',
         'sg552':'SG-552 Commando (Krieg 552)', 'aug':'Steyr AUG'
         }

class RandWeps(object):
    def __init__(self, userid):
        self.userid = userid
    def spawn(self):
        self.strip()
        self.give()
    def strip(self):
        es.server.queuecmd('es_xfire %s player_weaponstrip kill' % self.userid)
        es.server.queuecmd('es_xgive %s player_weaponstrip' % self.userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip strip' % self.userid)
        if not objectives:
            es.server.queuecmd('es_xfire %s hostage_entity kill' % self.userid)
            es.server.queuecmd('es_xfire %s func_hostage_rescue Disable;es_xfire %s func_bomb_target Disable' % (self.userid, self.userid))
        if not buyzone:
            es.server.queuecmd('es_fire %s func_buyzone Disable' % self.userid)
        es.delayed(0, 'es_xgive %s item_assaultsuit;es_xgive %s weapon_knife' % (self.userid, self.userid))
    def death(self, headshot):
        if attacker_wep:
            if attacker_wep == 1 and headshot or attacker_wep == 2:
                self.strip()
                self.give()
            es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', 100)
            if god:
                es.setplayerprop(self.userid, 'CBasePlayer.m_lifeState', 0)
                delayed(1, es.setplayerprop, (self.userid, 'CBasePlayer.m_lifeState', 512))
        es.server.queuecmd('est_RemoveIdle weapon')
    def give(self):
        rsec = rChoice(sec)
        rprim = rChoice(prim)
        es.delayed(0, 'es_xgive %s weapon_%s;es_xgive %s weapon_%s' % (self.userid, rsec, self.userid, rprim))
        es.delayed(0, 'es_xgive %s weapon_hegrenade;es_xgive %s weapon_flashbang;es_xgive %s weapon_flashbang;es_xgive %s weapon_smokegrenade' % (self.userid, self.userid, self.userid, self.userid))
        if es.getplayerteam(self.userid) == 3 and objectives and str(es.ServerVar('eventscripts_currentmap')).startswith('de_'):
            es.delayed(.1, 'es_xgive %s item_defuser' % self.userid)
        delayed(.15, es.sexec, (self.userid, 'use slot1'))
        delayed(.2, es.tell, (self.userid, '#multi', '#green[#lightgreenRandWeps#green] #defaultGot #lightgreen%s #green+ #lightgreen%s #defaultand Grenades.' % (names.get(rsec, rsec), names.get(rprim, prim))))

def load():
    config.execute()
    if objectives and not es.exists('saycommand', '!bomb'):
        es.regsaycmd('!bomb', 'randweps/getbomb')
    for userid in es.getUseridList():
        player[userid] = RandWeps(userid)

def unload():
    player.clear()
    for userid in es.getUseridList():
        es.server.queuecmd('es_xfire %s func_buyzone Enable;es_xfire %s func_hostage_rescue Enable;es_xfire %s func_bomb_target Enable' % (userid, userid, userid))

def getbomb():
    global bomb
    if objectives:
        userid = es.getcmduserid()
        if es.getplayerteam(userid) == 2:
            if not bomb:
                bomb = 1
                es.server.queuecmd('es_xgive %s weapon_c4' % userid)
            else:
                es.tell(userid, '#multi', '#green[#lightgreenRandWeps#green] #defaultBomb was already given, sorry.')
        else:
            es.tell(userid, '#multi', '#green[#lightgreenRandWeps#green] #defaultOnly Terrorists can get the Bomb, sorry.')

def player_spawn(ev):
    userid = int(ev['userid'])
    if player.has_key(userid):
        player[userid].spawn()

def player_death(ev):
    if ev['es_userteam'] != ev['es_attackerteam']:
        player[int(ev['attacker'])].death(int(ev['headshot']))

def round_start(ev):
    global bomb
    bomb = 0
    es.msg('#multi', "#green[#lightgreenRandWeps#green] #defaultis loaded. You'll get new free random Weapons.")
    if objectives:
        for userid in es.getUseridList():
            if es.getplayerteam(userid) == 2:
                delayed(.15, es.tell, (userid, '#multi', '#defaultThe first that types #lightgreen!bomb #defaultgets the bomb!'))
